﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SampleCode
{
    public delegate void DataSavedHandler(DataItem data);

    public partial class MainPage : UserControl
    {
        private SolidColorBrush STATUS_GREEN = new SolidColorBrush(Colors.Green);
        private SolidColorBrush STATUS_RED = new SolidColorBrush(Colors.Red);

        public event DataSavedHandler DataSavedEvent;

        public MainPage()
        {
            InitializeComponent();
            ((SampleCode.App)App.Current).ConnectionStatusChangedEvent += new ConnectionStatusChangedEventHandler(MainPage_ConnectionStatusChangedEvent);
            IndicateStatus(((SampleCode.App)App.Current).IsConnected);
            BindNews();
        }

        private void MainPage_ConnectionStatusChangedEvent(bool isConnected)
        {
            IndicateStatus(isConnected);
        }

        private void IndicateStatus(bool isConnected)
        {
            if (isConnected)
            {
                StatusEllipse.Fill = STATUS_GREEN;
            }
            else
            {
                StatusEllipse.Fill = STATUS_RED;
            }
        }

        private void BindNews()
        {
            NewsListBox.ItemsSource = ((SampleCode.App)App.Current).Repository.News;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataItem dataItem = new DataItem
            {
                Title = this.VehicleTextBox.Text,
                Detail = this.TextTextBox.Text
            };
            DataSavedHandler handler = this.DataSavedEvent;
            if (handler != null)
            {
                handler(dataItem);
            }

            this.VehicleTextBox.Text = string.Empty;
            this.TextTextBox.Text = string.Empty;
        }
    }
}
