﻿using System;
using System.Collections.Generic;

namespace SampleCode
{
    public delegate void ItemAddedEventHandler();

    public class ObservableQueue<T>
    {
        public event ItemAddedEventHandler ItemAddedEvent;

        private readonly Queue<T> queue = new Queue<T>();

        public void Enqueue(T item)
        {
            this.queue.Enqueue(item);
            ItemAddedEventHandler handler = this.ItemAddedEvent;
            if (handler != null)
            {
                handler();
            }
        }

        public T Peek()
        {
            return this.queue.Peek();
        }

        public T Dequeue()
        {
            return this.queue.Dequeue();
        }

        public Array ToArray()
        {
            return this.queue.ToArray();
        }

        public int Count
        {
            get
            {
                return this.queue.Count;
            }
        }
    }
}
