﻿using System;
using System.IO.IsolatedStorage;

namespace SampleCode
{
    public class QueueStore
    {
        private const string KEY = "PendingQueue";
        private IsolatedStorageSettings appSettings  = IsolatedStorageSettings.ApplicationSettings;

        public void SaveQueue(ObservableQueue<DataItem> queue)
        {
            appSettings.Remove(KEY);
            appSettings.Add(KEY, queue.ToArray());
            appSettings.Save();
        }

        public ObservableQueue<DataItem> LoadQueue()
        {
            ObservableQueue<DataItem> result = new ObservableQueue<DataItem>(); ;
            Array savedArray = null;

            if (appSettings.TryGetValue<Array>(KEY, out savedArray))
            {
                foreach (var item in savedArray)
                {
                    result.Enqueue(item as DataItem);
                }
            }

            return result;
        }
    }
}
